#pragma once
#include "stm32f10x.h"
#define	GPIO_READ_IN(x,y) ((_Bool)(GPIO##x->IDR&GPIO_Pin_##y))
#define	GPIO_READ_OUT(x,y) ((_Bool)(GPIO##x->ODR&GPIO_Pin_##y))
#define	GPIO_WRITE(x,y,z) do{if(z)GPIO##x->BSRR=GPIO_Pin_##y;else GPIO##x->BRR=GPIO_Pin_##y;}while(0)
#define GPIO_CONFIG(x,y,z) do{GPIO_InitTypeDef M={GPIO_Pin_##y,GPIO_Speed_50MHz,GPIO_Mode_##z};GPIO_Init(GPIO##x,&M);}while(0)
#define GPIO_INVERSE(x,y) do{if(GPIO_READ_OUT(x,y))GPIO_WRITE(x,y,0);else GPIO_WRITE(x,y,1);}while(0)
#define DAC_CONFIG(x) do{DAC_InitTypeDef M={DAC_Trigger_None,DAC_OutputBuffer_Disable,DAC_LFSRUnmask_Bit0,\
		DAC_WaveGeneration_None};DAC_Init(DAC_Channel_##x,&M);DAC_Cmd(DAC_Channel_##x,ENABLE);}while(0)
#define DAC_SET(x) do{DAC_SetChannel1Data(DAC_Align_8b_R,(x));}while(0)
#define ADC_CONFIG(x) do{ADC_InitTypeDef M={ADC_Mode_Independent,DISABLE,DISABLE,ADC_ExternalTrigConv_None,\
		ADC_DataAlign_Left,1};ADC_Init(ADC1,&M);ADC_Cmd(ADC1,ENABLE);ADC_RegularChannelConfig\
		(ADC1,(x),1,ADC_SampleTime_239Cycles5);ADC_SoftwareStartConvCmd(ADC1,ENABLE);}while(0)
#define ADC_GET() (ADC_SoftwareStartConvCmd(ADC1,ENABLE),ADC_GetConversionValue(ADC1))
#define EXTI_CONFIG(a,b,c,d) do{GPIO_EXTILineConfig(GPIO_PortSourceGPIO##a,GPIO_PinSource##b);\
		EXTI_InitTypeDef M={EXTI_##c,EXTI_Mode_Interrupt,EXTI_Trigger_##d,ENABLE};EXTI_Init(&M);}while(0)
#define RCC_CONFIG_AHB(x) do{RCC_AHBPeriphClockCmd(RCC_AHBPeriph_##x,ENABLE);}while(0)
#define RCC_CONFIG_APB1(x) do{RCC_APB1PeriphClockCmd(RCC_APB1Periph_##x,ENABLE);}while(0)
#define RCC_CONFIG_APB2(x) do{RCC_APB2PeriphClockCmd(RCC_APB2Periph_##x,ENABLE);}while(0)
#define NVIC_CONFIG(x,y) do{NVIC_InitTypeDef M={x,y,0,ENABLE};NVIC_Init(&M);}while(0)
#define TICK_CONFIG(x,y) do{SysTick_Config(x);NVIC_SetPriority(SysTick_IRQn,y);}while(0)
#define SYS_DELAY_US(a) do{int _delay_=12*(a);while(_delay_--);}while(0)
#define SYS_DELAY_MS(a) do{int _delay_=12000*(a);while(_delay_--);}while(0)
#define SYS_DELAY_S(a) do{int _delay_=12000000*(a);while(_delay_--);}while(0)
#define FLASH_WRITE FLASH_ProgramHalfWord
#define FLASH_READ(x) (*(u8*)(x))
#define FLASH_ADDRESS (0x8003000)
#define FLASH_END (0x8070000)
